var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var RogueRpg;
(function (RogueRpg) {
    // TODO: Determine when particle emitters need to be added and removed and persisted
    var ParticleEmitter = /** @class */ (function () {
        function ParticleEmitter(originalParticle, emitInterval, sourceLocation, condition) {
            this.originalParticle = originalParticle;
            this.emitInterval = emitInterval;
            this.sourceLocation = sourceLocation;
            this.condition = condition;
            this.timeRemaining = 0;
            this.particles = [];
        }
        ParticleEmitter.UpdateAndRenderAll = function (context, deltaTime) {
            for (var i = 0; i < ParticleEmitter.Emitters.length; i++) {
                var e = ParticleEmitter.Emitters[i];
                for (var j = e.particles.length - 1; j >= 0; j--) {
                    var p = e.particles[j];
                    p.location.x += p.velocity.x;
                    p.location.y += p.velocity.y;
                    if (p.image) {
                        var im = RogueRpg.Images.get(p.image);
                        context.drawImage(im, p.location.x - RogueRpg.Helpers.OriginX - im.width / 2, p.location.y - RogueRpg.Helpers.OriginY - im.height / 2);
                    }
                    else if (p.animation) {
                        if (p.animation.update(RogueRpg.Game.deltaTime)) {
                            p.animation.draw(context);
                        }
                    }
                    p.timeRemaining -= deltaTime;
                    if (p.timeRemaining <= 0) {
                        e.particles.splice(j, 1);
                    }
                }
                if (e.condition && e.condition()) {
                    e.timeRemaining -= deltaTime;
                    if (e.timeRemaining <= 0) {
                        e.timeRemaining += e.emitInterval;
                        var location = (typeof e.sourceLocation === "function") ? e.sourceLocation() : Location.clone(e.sourceLocation);
                        var p = new Particle(location, new Location(0.8 - Math.random() * 1.6, 0.8 - Math.random() * 1.6), e.originalParticle.image, e.originalParticle.timeRemaining);
                        if (e.originalParticle.animationKey) {
                            p.animation = RogueRpg.Images.Sprites.Slow.getInstance(location);
                        }
                        e.particles.push(p);
                    }
                }
            }
        };
        ParticleEmitter.Emitters = [];
        return ParticleEmitter;
    }());
    RogueRpg.ParticleEmitter = ParticleEmitter;
    var Particle = /** @class */ (function () {
        function Particle(location, velocity, image, timeRemaining, animation) {
            this.location = location;
            this.velocity = velocity;
            this.image = image;
            this.timeRemaining = timeRemaining;
            this.animation = animation;
        }
        return Particle;
    }());
    RogueRpg.Particle = Particle;
    var Utils = /** @class */ (function () {
        function Utils() {
        }
        Utils.drawRadialGradient = function (ctx, x, y, r, color) {
            var protonGradient = ctx.createRadialGradient(x, y, 0, x, y, r);
            protonGradient.addColorStop(0, RogueRpg.Rgba.stringify(color));
            protonGradient.addColorStop(1, RogueRpg.Rgba.stringify(RogueRpg.Rgba.clone(color, 0)));
            ctx.fillStyle = protonGradient;
            ctx.fillRect(x - r, y - r, r * 2, r * 2);
        };
        return Utils;
    }());
    RogueRpg.Utils = Utils;
    var Location = /** @class */ (function () {
        function Location(x, y) {
            this.x = x || 0;
            this.y = y || 0;
        }
        Location.equals = function (loc1, loc2) {
            return loc1.x === loc2.x && loc1.y === loc2.y;
        };
        Location.clone = function (location) {
            return new Location(location.x, location.y);
        };
        return Location;
    }());
    RogueRpg.Location = Location;
    var MovingLocation = /** @class */ (function (_super) {
        __extends(MovingLocation, _super);
        function MovingLocation() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return MovingLocation;
    }(Location));
    RogueRpg.MovingLocation = MovingLocation;
    var MovingQuantity = /** @class */ (function (_super) {
        __extends(MovingQuantity, _super);
        function MovingQuantity() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return MovingQuantity;
    }(MovingLocation));
    RogueRpg.MovingQuantity = MovingQuantity;
    function ImageToCanvas(img) {
        var canvas = document.createElement("canvas");
        canvas.width = img.width;
        canvas.height = img.height;
        var ctx = canvas.getContext("2d");
        ctx.clearRect(0, 0, img.width, img.height);
        ctx.drawImage(img, 0, 0);
        return canvas;
    }
    RogueRpg.ImageToCanvas = ImageToCanvas;
})(RogueRpg || (RogueRpg = {}));
//# sourceMappingURL=GameUtils.js.map