/// <reference path="game.ts" />
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var RogueRpg;
(function (RogueRpg) {
    "use strict";
    var SpecialDroppedItem = /** @class */ (function () {
        function SpecialDroppedItem(value, drawX, drawY, name, speed) {
            this.value = value;
            this.drawX = drawX;
            this.drawY = drawY;
            this.name = name;
            this.speed = speed;
            this.isAvailable = false;
        }
        return SpecialDroppedItem;
    }());
    RogueRpg.SpecialDroppedItem = SpecialDroppedItem;
    var DroppedItem = /** @class */ (function () {
        function DroppedItem(state) {
            this.state = state;
            if (state) {
                if (state.itemState.baseDamage) {
                    this.item = new Weapon(0, 0, "", state.itemState);
                }
                else if (state.itemState.baseReduction) {
                    this.item = new Shield(0, 0, "", state.itemState);
                }
                else if (state.itemState.baseDefense) {
                    this.item = new Armor(0, 0, "", state.itemState);
                }
                else {
                    this.item = new Accessory(0, 0, "", state.itemState);
                }
                this.drawX = state.drawX;
                this.drawY = state.drawY;
                this.drawHeight = state.drawHeight;
                this.drawWidth = state.drawWidth;
            }
        }
        DroppedItem.prototype.getItemState = function () {
            return {
                itemState: this.item.getItemState(),
                drawX: this.drawX,
                drawY: this.drawY,
                drawHeight: this.drawHeight,
                drawWidth: this.drawWidth
            };
        };
        return DroppedItem;
    }());
    RogueRpg.DroppedItem = DroppedItem;
    var MagicProperty = /** @class */ (function () {
        function MagicProperty(propertyName, propertyValue, isSuper) {
            this.propertyName = propertyName;
            this.propertyValue = propertyValue;
            this.isSuper = isSuper;
        }
        MagicProperty.getPropertyShortName = function (prop) {
            return prop.propertyName.substr(prop.propertyName.lastIndexOf("_") + 1);
        };
        MagicProperty.getDisplayString = function (prop) {
            var isPercent = prop.propertyName.indexOf("percent_") == 0;
            var propVal;
            if (MagicProperty.getPropertyShortName(prop) == "力量") {
                propVal = "+" + red(prop.propertyValue);
            }
            else if (MagicProperty.getPropertyShortName(prop) == "灵敏") {
                propVal = "+" + blue(prop.propertyValue);
            }
            else if (MagicProperty.getPropertyShortName(prop) == "生命") {
                propVal = "+" + green(prop.propertyValue);
            }
            else if (MagicProperty.getPropertyShortName(prop) == "运气") {
                propVal = "+" + yellow(prop.propertyValue);
            }
            else if (MagicProperty.getPropertyShortName(prop) == "生命偷取") {
                propVal = "+" + green(prop.propertyValue);
            }
            else {
                propVal = "+" + prop.propertyValue;
            }
            propVal += (isPercent || propVal == "flat_lifesteal") ? "% " : " ";
            propVal += MagicProperty.getPropertyShortName(prop);
            return propVal;
        };
        return MagicProperty;
    }());
    RogueRpg.MagicProperty = MagicProperty;
    ;
    var ItemState = /** @class */ (function () {
        function ItemState() {
        }
        return ItemState;
    }());
    RogueRpg.ItemState = ItemState;
    var Item = /** @class */ (function () {
        function Item(level, rarity, state) {
            this.magicProperties = [];
            this._propertyTable = [{ chance: 2, property: "flat_life" },
                { chance: 1, property: "percent_life" },
                { chance: 2, property: "flat_strength" },
                { chance: 2, property: "flat_dexterity" },
                { chance: 1, property: "percent_strength" },
                { chance: 1, property: "percent_dexterity" },
                { chance: 1, property: "flat_lifesteal" },
                { chance: 1, property: "flat_luck" },
            ];
            if (state) {
                this.level = state.level;
                this.magicProperties = state.magicProperties;
                this.fixedFullName = state.fixedFullName;
                this.type = state.type;
                this.imageType = state.imageType;
                this.rarity = state.rarity;
            }
            else {
                this.level = level;
                this.rarity = rarity;
            }
        }
        Object.defineProperty(Item.prototype, "image", {
            get: function () {
                return this.imageType || this.type;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Item.prototype, "fullName", {
            get: function () {
                return this.fixedFullName || (this.magicProperties.length > 0 ? this.type + " of " + MagicProperty.getPropertyShortName(this.magicProperties[0]) : this.type);
            },
            enumerable: true,
            configurable: true
        });
        Item.prototype.getPropertyTable = function () {
            var propertyTable = this._propertyTable.splice(0);
            for (var i = 0; i < propertyTable.length; i++) {
                var c = propertyTable[i];
                var multiplier = 1;
                if (c.property == "percent_str" && RogueRpg.Helpers.hero.level < 10) {
                    multiplier *= RogueRpg.Helpers.hero.level / 10;
                }
                if (c.property == "percent_dex" && RogueRpg.Helpers.hero.level < 10) {
                    multiplier *= RogueRpg.Helpers.hero.level / 10;
                }
                if (c.property == "flat_damage" && RogueRpg.Level[RogueRpg.L.DropChanceDmg]) {
                    multiplier += 1;
                }
                if (c.property == "percent_damage" && RogueRpg.Level[RogueRpg.L.DropChanceDmgPercent]) {
                    multiplier += 2;
                }
                if (c.property == "flat_defense" && RogueRpg.Level[RogueRpg.L.DropChanceDef]) {
                    multiplier += 1;
                }
                if (c.property == "percent_defense" && RogueRpg.Level[RogueRpg.L.DropChanceDefPercent]) {
                    multiplier += 2;
                }
                if (c.property == "flat_life" && RogueRpg.Level[RogueRpg.L.DropChanceLife]) {
                    multiplier += 1;
                }
                if (c.property == "flat_str" && RogueRpg.Level[RogueRpg.L.DropChanceStr]) {
                    multiplier += 1;
                }
                if (c.property == "flat_dex" && RogueRpg.Level[RogueRpg.L.DropChanceDex]) {
                    multiplier += 1;
                }
                if (c.property == "flat_speed" && RogueRpg.Level[RogueRpg.L.DropChanceSpeed]) {
                    multiplier += 1;
                }
                if (c.property == "flat_luck" && RogueRpg.Level[RogueRpg.L.DropChanceLuck]) {
                    multiplier += RogueRpg.Level[RogueRpg.L.DropChanceLuck];
                }
                if (c.property == "percent_speed" && RogueRpg.Level[RogueRpg.L.DropChanceSpeedPercent]) {
                    multiplier += 2;
                }
                if (c.property == "flat_lifesteal" && RogueRpg.Level[RogueRpg.L.DropChanceLifestealWeapon] && this.type == "Weapon") {
                    multiplier += 2;
                }
                if (c.property == "flat_lifesteal" && RogueRpg.Level[RogueRpg.L.NoLifesteal]) {
                    multiplier = 0;
                }
                if ((c.property == "flat_life" || c.property == "percent_life") && RogueRpg.Level[RogueRpg.L.DropChanceLifeArmor] && this.type == "Armor") {
                    multiplier += 3;
                }
                if ((c.property == "flat_strength" || c.property == "percent_strength") && RogueRpg.Level[RogueRpg.L.DropChanceStrShield] && this.type == "Shield") {
                    multiplier += 3;
                }
                if ((c.property == "flat_reduction" || c.property == "percent_reduction") && RogueRpg.Level[RogueRpg.L.DropChanceReduction] && this.type == "Shield") {
                    multiplier += 1;
                }
                c.chance *= multiplier;
            }
            return propertyTable;
        };
        Item.generateEquipment = function (type, level, rarity, itemType) {
            if (rarity == 5) {
                level = level + 1;
            }
            if (rarity == 6) {
                level = Math.floor(level * 1.05 + 2);
            }
            if (rarity >= 7) {
                level = Math.floor(level + 2);
            }
            var item;
            if (type == "Weapon") {
                item = new Weapon(level, rarity, itemType);
            }
            else if (type === "Shield") {
                item = new Shield(level, rarity, itemType);
            }
            else if (type === "Armor") {
                item = new Armor(level, rarity, itemType);
            }
            else {
                item = new Accessory(level, rarity, itemType);
            }
            var propertyTable = item.getPropertyTable();
            var hasBigProperty = false;
            for (var i = 1; i < Math.min(rarity, 7); i++) {
                var chanceType = Item.pickProperty(propertyTable);
                var isBigProperty = false;
                if (!hasBigProperty && RogueRpg.Helpers.game.playerRandom.call(RogueRpg.Helpers.game, true) > 0.8) {
                    isBigProperty = true;
                    hasBigProperty = true;
                }
                var property = new MagicProperty(chanceType.property, Item.generatePropertyValueForItem(chanceType, rarity, item, isBigProperty));
                item.magicProperties.push(property);
            }
            return item;
        };
        // Contains all the logic for properties
        // isBigProperty applies an additional multiplier (33% bonus) to any property
        Item.generatePropertyValueForItem = function (type, rarity, item, isBigProperty) {
            var val = 0;
            var random = RogueRpg.Helpers.game.playerRandom.bind(RogueRpg.Helpers.game, true);
            if (type.property == "flat_life") {
                val = randInt(item.level * 1.5, item.level * 3) + 8;
                if (item.level > 12) {
                    val = Math.round(val * Math.pow(item.level - 11, 0.2));
                }
                if (item instanceof Weapon) {
                    val = Math.floor(val * 1.2); // Life related effects on weapons have bonus strength
                }
                if (RogueRpg.Level[RogueRpg.L.DropChanceLifeArmor] && item instanceof Armor) {
                    val = Math.floor(item.level + val * 1.25);
                }
            }
            if (type.property == "percent_life") {
                val = 10 + item.level / 2 + random() * (10 + item.level / 1.5);
                // Soft cap at 50% bonus life
                if (val > 50) {
                    val = 50 + (val - 50) * 2 / 3;
                }
                if (item instanceof Weapon) {
                    val = Math.floor(val * 1.2); // Life related effects on weapons have bonus strength
                }
                //if (Level[L.DropChanceLifeArmor] && item instanceof Armor) {
                //    val = Math.floor(val * 1.3)
                //}
            }
            if (type.property == "flat_strength") {
                val = randInt(item.level / 2, item.level) + randIntMap(5, 7);
                if (RogueRpg.Level[RogueRpg.L.DropChanceStrShield] && item instanceof Shield) {
                    val = Math.floor(val * 1.3);
                }
            }
            if (type.property == "flat_lifesteal") {
                val = randInt(3, 4);
                if (item instanceof Weapon) {
                    val = Math.floor(1 + val); // Life related effects on weapons have bonus strength
                }
            }
            if (type.property == "flat_luck") {
                val = randInt(10, 15 + Math.sqrt(item.level)); // TODO: These values need adjusting
            }
            if (type.property == "percent_strength") {
                val = 10 + Math.sqrt(item.level / 2) + random() * Math.sqrt(10 + item.level);
                if (RogueRpg.Level[RogueRpg.L.DropChanceStrShield] && item instanceof Shield) {
                    val = Math.floor(val * 1.3);
                }
            }
            if (type.property == "flat_dexterity") {
                val = randInt(item.level / 2, item.level) + randIntMap(5, 7);
            }
            if (type.property == "percent_dexterity") {
                val = 10 + Math.sqrt(item.level / 2) + random() * Math.sqrt(10 + item.level);
            }
            if (type.property == "flat_damage") {
                val = randInt(1 + item.level / 4, 2 + 3 * item.level / 5);
            }
            if (type.property == "percent_damage") {
                val = 15 + Math.sqrt(item.level) + random() * (10 + Math.sqrt(item.level));
            }
            if (type.property == "flat_speed") {
                val = Math.min(9, randInt(1, 3 + item.level / 12));
            }
            if (type.property == "percent_speed") {
                val = Math.min(25, 5 + item.level / 5 + random() * (10 + item.level / 4));
                if (RogueRpg.Level[RogueRpg.L.DropChanceSpeedPercent] && item instanceof Accessory) {
                    val = Math.floor(val * 1.4);
                }
            }
            if (type.property == "flat_reduction") {
                // TODO: Problem - this scales HORRIBLY towards end game. Maybe that's OK?
                val = 1 + (item.level / 3) + random() * (1 + item.level / 4);
                if (item.level > 10) {
                    val = val * Math.pow(item.level - 9, 0.35); // Scale a little better later on
                }
            }
            if (type.property == "percent_reduction") {
                val = 25 + item.level / 2 + random() * (20 + item.level);
            }
            if (type.property == "flat_defense") {
                val = 1 + (item.level / 2) + random() * (1 + item.level / 2);
            }
            if (type.property == "percent_defense") {
                val = 20 + Math.sqrt(item.level) + random() * (20 + item.level);
            }
            if (rarity == 6) {
                val = val * 1.15;
            }
            else if (rarity >= 7) {
                val = val * 1.25;
            }
            if (isBigProperty) {
                val = Math.floor(val * 1.3);
            }
            return Math.round(val);
        };
        // Abstracts away the retrieval of a value
        Item.prototype.getPropertyValue = function (property) {
            for (var i = 0; i < this.magicProperties.length; i++) {
                if (this.magicProperties[i].propertyName === property) {
                    return this.magicProperties[i].propertyValue;
                }
            }
            return 0;
        };
        Item.prototype.getMainStatText = function () { return ""; };
        Item.prototype.getFlavorText = function () {
            if (this.rarity == 1) {
                return "这是一个平凡的装备。";
            }
            else if (this.rarity == 2) {
                return "这装备是神奇的。";
            }
            else if (this.rarity == 3) {
                return "这件装备被强大的魔法所吸引。";
            }
            else if (this.rarity == 4) {
                return "这是仅在传说中提及的装备。";
            }
            else if (this.rarity == 5) {
                return "这是一种不可思议的力量。";
            }
            else if (this.rarity == 6) {
                return "即使是最强大的神也被这个装备的力量所压倒。";
            }
            else if (this.rarity >= 7) {
                return "这个装备以不可能的力量动摇现实的基础。";
            }
            return "";
        };
        Item.prototype.getItemState = function () {
            return {
                magicProperties: this.magicProperties,
                level: this.level,
                rarity: this.rarity,
                type: this.type,
                imageType: this.imageType,
                fixedFullName: this.fixedFullName,
                // These three identify the type of the item in addition to the specific values (if necessary)
                baseDefense: 0,
                baseDamage: 0,
                baseReduction: 0,
                baseAttackSpeed: 0
            };
        };
        Item.pickProperty = function (propertyTable) {
            var totalChances = 0;
            for (var i = 0; i < propertyTable.length; i++) {
                totalChances += propertyTable[i].chance;
            }
            var chance = Math.random() * totalChances; // Unaffected by luck
            for (var i = propertyTable.length - 1; i >= 0; i--) {
                chance -= propertyTable[i].chance;
                if (chance <= 0) {
                    var property = propertyTable[i];
                    propertyTable.splice(i, 1);
                    return property;
                }
            }
            return propertyTable[0];
        };
        return Item;
    }());
    RogueRpg.Item = Item;
    var ItemNames = /** @class */ (function () {
        function ItemNames() {
        }
        ItemNames.SpecialWeaponNames = [
            "Earthsplitter",
            "Instrument of Violence",
            "Fountain of Terror",
            "Denial of Life",
            "Anger Thrust",
            "Death Blade",
            "Juggernaut Blade",
            "The Betrayer",
        ];
        ItemNames.ImpossibleWeaponNames = [
            "Chaotic Damage",
            "Infinitely Silent",
            "Galaxies Asunder",
            "Eternal Grudge",
            "Destruction",
        ];
        ItemNames.SpecialShieldNames = [
            "The Wall",
            "Swordbreaker",
            "The Commandment",
            "Unbreakable Slab",
            "Protection",
        ];
        ItemNames.ImpossibleShieldNames = [
            "The Boundary",
            "All-Stopper",
            "End of Pain",
            "Statement of Invincibility",
            "Singularity Ward"
        ];
        ItemNames.SpecialArmorNames = [
            "Shelter",
            "Grand Armor",
            "Mark of Defense",
            "Impenetrable Shroud",
        ];
        ItemNames.ImpossibleArmorNames = [
            "Untouchable",
            "Infinity Plate",
            "Nonexistent Surface",
            "Grandest Armor"
        ];
        ItemNames.SpecialRingNames = [
            "Heart of the Sun",
            "Star Gem",
            "True Symbol",
            "Radiant and Pure",
            "Ring of the Ancients"
        ];
        ItemNames.ImpossibleRingNames = [
            "Core of the Universe",
            "Infinity Gem",
            "Mobius Spiral",
            "Life and Death",
            "Dark Matter",
            "Redemption Ring",
        ];
        return ItemNames;
    }());
    RogueRpg.ItemNames = ItemNames;
    var Weapon = /** @class */ (function (_super) {
        __extends(Weapon, _super);
        function Weapon(level, rarity, type, state) {
            var _this = _super.call(this, level, rarity, state) || this;
            if (state) {
                _this._baseDamage = state.baseDamage;
                _this._baseAttackSpeed = state.baseAttackSpeed;
            }
            else {
                if (type == "Wraps") {
                    _this.type = "Wraps";
                    _this._baseDamage = Math.floor(1 + Math.log(RogueRpg.Helpers.game.maxMultiplierUnlocked) / Math.log(2));
                    _this._baseAttackSpeed = 500;
                    return _this;
                }
                if (type && type.indexOf("Scumbasher") === 0) {
                    _this.type = type;
                    var mult = 1;
                    if (type.indexOf("+1") > 0) {
                        mult = 2;
                    }
                    if (type.indexOf("+2") > 0) {
                        mult = 3;
                    }
                    if (type.indexOf("+3") > 0) {
                        mult = 4;
                    }
                    _this._baseDamage = 2;
                    _this._baseAttackSpeed = 1000;
                    if (rarity == 2) {
                        _this._baseDamage = 8;
                        _this._baseAttackSpeed = 900;
                    }
                    else if (rarity == 3) {
                        _this._baseDamage = 16;
                        _this._baseAttackSpeed = 800;
                    }
                    else if (rarity == 4) {
                        _this._baseDamage = 32;
                        _this._baseAttackSpeed = 700;
                    }
                    else if (rarity == 5) {
                        _this._baseDamage = 64;
                        _this._baseAttackSpeed = 600;
                    }
                    else if (rarity == 6) {
                        _this._baseDamage = 128;
                        _this._baseAttackSpeed = 500;
                    }
                    else if (rarity >= 7) {
                        _this._baseDamage = 256;
                        _this._baseAttackSpeed = 400;
                    }
                    _this._baseDamage *= mult;
                    return _this;
                }
                _this._baseDamage = randInt(1 + _this.level, (1 + _this.level) * 1.5);
                if (type) {
                    _this.type = type;
                }
                else {
                    var roll = RogueRpg.Helpers.game.playerRandom(true);
                    var chanceForSlowWeapon = 0.5 + (RogueRpg.Level[RogueRpg.L.DropChanceSlow] - RogueRpg.Level[RogueRpg.L.DropChanceFast]) * 0.25;
                    var isFast = Math.random() > chanceForSlowWeapon ? true : false; // Unaffected by luck
                    // Choose a tier, then choose a weapon from that tier
                    if (Math.random() > 0.9 && RogueRpg.Helpers.game.hero.state.multiplier > 2
                        && level * Math.random() > 20 && rarity > 3) {
                        _this.type = "Kingsword";
                        // TODO: Also drop from some sort of boss?
                    }
                    else if (Math.random() > 0.9 && RogueRpg.Helpers.game.hero.state.multiplier > 1
                        && level * Math.random() > 10 && rarity > 2) {
                        if (isFast) {
                            _this.type = "Fire Sword";
                        }
                        else {
                            _this.type = "Ice Sword";
                        }
                    }
                    else if (roll > 0.9 && level * Math.random() > 15 && !isFast) {
                        _this.type = "Greataxe";
                    }
                    else if (roll > 0.9 && level * Math.random() > 20) {
                        if (isFast) {
                            _this.type = "Crystal Shard";
                        }
                        else {
                            _this.type = "Greatsword";
                        }
                    }
                    else if (roll > 0.9 && level * Math.random() > 12) {
                        if (isFast) {
                            _this.type = "Katana";
                        }
                        else {
                            _this.type = "Lance";
                        }
                    }
                    else if (roll > 0.8 && level * Math.random() > 9) {
                        if (isFast) {
                            _this.type = "Kama";
                        }
                        else {
                            _this.type = "Longsword";
                        }
                    }
                    else if (roll > 0.6 && level * Math.random() > 6) {
                        if (isFast) {
                            _this.type = "Katar";
                        }
                        else {
                            _this.type = "Gladius";
                        }
                    }
                    else if (roll > 0.4 && level * Math.random() > 3) {
                        if (isFast) {
                            _this.type = "Scimitar";
                        }
                        else {
                            _this.type = "Halberd";
                        }
                    }
                    else if (roll < 0.6 && level * Math.random() > 3) {
                        if (isFast) {
                            if (Math.random() < .3) {
                                _this.type = "Kukri";
                            }
                            else {
                                _this.type = "Dagger";
                            }
                        }
                        else {
                            _this.type = "Mace";
                        }
                    }
                    else if (roll > 0.25 && level > 1) {
                        if (isFast) {
                            _this.type = "Tiger Claws";
                        }
                        else {
                            _this.type = "Spear";
                        }
                    }
                    else if (roll > 0.15) {
                        if (isFast) {
                            _this.type = "Hatchet";
                        }
                        else {
                            _this.type = "Morning Star";
                        }
                    }
                    else {
                        if (isFast) {
                            _this.type = "Knife";
                        }
                        else {
                            _this.type = "Sword";
                        }
                    }
                }
                switch (_this.type) {
                    case "Kingsword":
                        _this._baseDamage = randInt(level * 3, level * 5) + 1;
                        _this._baseAttackSpeed = 777;
                        break;
                    case "Crystal Shard":
                        _this._baseDamage = randInt(level * 1.2, level * 1.9) + 3;
                        _this._baseAttackSpeed = 600;
                        break;
                    case "Fire Sword":
                        _this._baseDamage = randInt(level * 1.4, level * 1.9) + 3;
                        _this._baseAttackSpeed = 700;
                        break;
                    case "Ice Sword":
                        _this._baseDamage = randInt(level * 1.9, level * 2.7) + 3;
                        _this._baseAttackSpeed = 1100;
                        break;
                    case "Greatsword":
                        _this._baseDamage = randInt(level * 2, level * 3) + 1;
                        _this._baseAttackSpeed = 1500;
                        break;
                    case "Decapitator":
                        _this._baseDamage = randInt(level * 2, level * 3) + 1;
                        _this._baseAttackSpeed = 1500;
                        break;
                    case "Blade of the Dreadking":
                        _this.fixedFullName = "Blade of the Dreadking";
                        _this._baseDamage = randInt(level * 1.6, level * 2);
                        _this._baseAttackSpeed = 750;
                        break;
                    case "Greataxe":
                        _this._baseDamage = randInt(level * 4, level * 7);
                        _this._baseAttackSpeed = 3500;
                        break;
                    case "Lance":
                        _this._baseDamage = randInt(level * 2.5, level * 5);
                        _this._baseAttackSpeed = 2200;
                        break;
                    case "Katana":
                        _this._baseDamage = randInt(level, level * 1.2);
                        _this._baseAttackSpeed = 550;
                        break;
                    case "Kama":
                        _this._baseDamage = randInt(level * 1.2, level * 1.3);
                        _this._baseAttackSpeed = 700;
                        break;
                    case "Longsword":
                        _this._baseDamage = randInt(level * 1.4, level * 1.8);
                        _this._baseAttackSpeed = 900;
                        break;
                    case "Katar":
                        _this._baseDamage = randInt(level * 0.7, level * 0.9);
                        _this._baseAttackSpeed = 500;
                        break;
                    case "Gladius":
                        _this._baseDamage = randInt(level * 1.6, level * 2.2);
                        _this._baseAttackSpeed = 1200;
                        break;
                    case "Kukri":
                        _this._baseDamage = randInt(level * .9, level * 1.3);
                        _this._baseAttackSpeed = 650;
                        break;
                    case "Dagger":
                        _this._baseDamage = randInt(level * .7, level);
                        _this._baseAttackSpeed = 600;
                        break;
                    case "Mace":
                        _this._baseDamage = randInt(level * 1.3, level * 1.6);
                        _this._baseAttackSpeed = 1000;
                        break;
                    case "Halberd":
                        _this._baseDamage = randInt(level * 2.2, level * 3);
                        _this._baseAttackSpeed = 2000;
                        break;
                    case "Scimitar":
                        _this._baseDamage = randInt(level * 0.85, level * 1.3);
                        _this._baseAttackSpeed = 700;
                        break;
                    case "Tiger Claws":
                        _this._baseDamage = randInt(level * .5, level * .7);
                        _this._baseAttackSpeed = 550;
                        break;
                    case "Spear":
                        _this._baseDamage = randInt(level * 1.3, level * 1.8);
                        _this._baseAttackSpeed = 1500;
                        break;
                    case "Knife":
                        _this._baseDamage = randInt(level * .5, level * .7);
                        _this._baseAttackSpeed = 600;
                        break;
                    case "Sword":
                        _this._baseDamage = randInt(level * 1.2, level * 1.4);
                        _this._baseAttackSpeed = 1100;
                        break;
                    case "Hatchet":
                        _this._baseDamage = randInt(level * .65, level * 1.05);
                        _this._baseAttackSpeed = 750;
                        break;
                    case "Morning Star":
                        _this._baseDamage = randInt(level * 1.2, level * 1.9);
                        _this._baseAttackSpeed = 1400;
                        break;
                    case "Simple Bow":
                        _this._baseDamage = 2;
                        _this._baseAttackSpeed = 1500;
                        break;
                    case "Bow":
                        _this._baseDamage = randInt(level, level * 1.4) + 1;
                        _this._baseAttackSpeed = 1200;
                        break;
                    case "Angular Bow":
                        _this._baseDamage = randInt(level * 1.4, level * 2) + 1;
                        _this._baseAttackSpeed = 2400;
                        break;
                    case "Recurve Bow":
                        _this._baseDamage = randInt(level, level * 1.2) + 1;
                        _this._baseAttackSpeed = 900;
                        break;
                    case "Crimson Bow":
                        _this._baseDamage = randInt(level * 1.1, level * 1.3) + 2;
                        _this._baseAttackSpeed = 800;
                        break;
                    case "Sylvan Bow":
                        _this._baseDamage = randInt(level * 1.5, level * 2.8) + 1;
                        _this._baseAttackSpeed = 1300;
                        break;
                    case "Shadow Bow":
                        _this._baseDamage = randInt(level * 2, level * 4) + 1;
                        _this._baseAttackSpeed = 2100;
                        break;
                    case "Golden Bow":
                        _this._baseDamage = randInt(level * 1.7, level * 2.4) + 1;
                        _this._baseAttackSpeed = 800;
                        break;
                    default:
                        _this._baseDamage = 1;
                        _this._baseAttackSpeed = 1000;
                }
                _this._baseDamage = 1 + _this._baseDamage;
                if (rarity > 4) {
                    _this._baseDamage = Math.floor(_this._baseDamage * 1.3);
                }
                if (rarity == 6) {
                    _this._baseDamage = Math.floor(_this._baseDamage * 1.2);
                    var nameSelection = Math.random();
                    if (nameSelection < 0.4) {
                        _this.fixedFullName = RogueRpg.Helpers.SelectOne(ItemNames.SpecialWeaponNames);
                    }
                }
                if (rarity >= 7) {
                    _this._baseDamage = Math.floor(_this._baseDamage * 1.5);
                    _this.fixedFullName = RogueRpg.Helpers.SelectOne(ItemNames.ImpossibleWeaponNames);
                }
            }
            return _this;
        }
        Weapon.prototype.isFast = function () {
            return this.delay <= 750;
        };
        Object.defineProperty(Weapon.prototype, "damage", {
            get: function () {
                var damage = this._baseDamage;
                damage += this.getPropertyValue("flat_damage");
                damage *= 1 + this.getPropertyValue("percent_damage") / 100;
                return Math.round(damage);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Weapon.prototype, "delay", {
            get: function () {
                return this._baseAttackSpeed;
            },
            enumerable: true,
            configurable: true
        });
        Weapon.prototype.getPropertyTable = function () {
            var table = [];
            table = table.concat(Weapon._weaponPropertyTable);
            table = table.concat(_super.prototype.getPropertyTable.call(this));
            return table;
        };
        Weapon.prototype.getMainStatText = function () { return "伤害: " + green(this.damage) + " CD: " + green(this.delay); };
        Weapon.prototype.getItemState = function () {
            return {
                magicProperties: this.magicProperties,
                level: this.level,
                rarity: this.rarity,
                type: this.type,
                imageType: this.imageType,
                fixedFullName: this.fixedFullName,
                // These three identify the type of the item in addition to the specific values (if necessary)
                baseDefense: 0,
                baseDamage: this._baseDamage,
                baseReduction: 0,
                baseAttackSpeed: this._baseAttackSpeed
            };
        };
        Weapon._weaponPropertyTable = [{ chance: 3, property: "shanghai" },
            { chance: 2, property: "percent_damage" },
        ];
        return Weapon;
    }(Item));
    RogueRpg.Weapon = Weapon;
    var Stat = /** @class */ (function () {
        function Stat() {
        }
        return Stat;
    }());
    RogueRpg.Stat = Stat;
    var Shield = /** @class */ (function (_super) {
        __extends(Shield, _super);
        function Shield(level, rarity, type, state) {
            var _this = _super.call(this, level, rarity, state) || this;
            if (state) {
                _this.baseReduction = state.baseReduction;
            }
            else {
                if (type) {
                    _this.type = type;
                }
                else {
                    var roll = RogueRpg.Helpers.game.playerRandom(true);
                    if (roll > 0.9 && level * Math.random() > 15 && rarity > 2) {
                        _this.type = "Ward";
                    }
                    else if (roll > 0.9 && level * Math.random() > 14 && rarity > 1) {
                        _this.type = "Holy Shield";
                    }
                    else if (roll > 0.9 && level * Math.random() > 12) {
                        _this.type = "Round Shield";
                    }
                    else if (roll > 0.85 && level * Math.random() > 12) {
                        _this.type = "Aegis";
                    }
                    else if (roll > 0.7 && level * Math.random() > 9) {
                        _this.type = "Bulwark";
                    }
                    else if (roll > 0.55 && level * Math.random() > 6) {
                        _this.type = "Aspis";
                    }
                    else if (roll > 0.4 && level * Math.random() > 3) {
                        _this.type = "Protector";
                    }
                    else if (Math.random() > 0.6) {
                        _this.type = "Heavy Shield";
                    }
                    else {
                        _this.type = "Shield";
                    }
                }
                var reduction = Shield.Shields[_this.type];
                _this.baseReduction = randInt(level * reduction.low, level * reduction.high) + reduction.flat;
                if (rarity > 4) {
                    _this.baseReduction = _this.baseReduction + 5;
                }
                if (rarity == 6) {
                    var nameSelection = Math.random();
                    if (nameSelection < 0.3) {
                        _this.fixedFullName = RogueRpg.Helpers.SelectOne(ItemNames.SpecialShieldNames);
                    }
                }
                if (rarity >= 7) {
                    _this.baseReduction = Math.floor(_this.baseReduction * 1.5);
                    _this.fixedFullName = RogueRpg.Helpers.SelectOne(ItemNames.ImpossibleShieldNames);
                }
            }
            return _this;
        }
        Object.defineProperty(Shield.prototype, "reduction", {
            get: function () {
                var reduction = this.baseReduction;
                reduction += this.getPropertyValue("flat_reduction");
                reduction *= 1 + this.getPropertyValue("percent_reduction") / 100;
                return Math.round(reduction);
            },
            enumerable: true,
            configurable: true
        });
        Shield.prototype.getPropertyTable = function () {
            var table = [];
            table = table.concat(Shield._shieldPropertyTable);
            table = table.concat(_super.prototype.getPropertyTable.call(this));
            return table;
        };
        Shield.prototype.getMainStatText = function () { return "防御: " + green(this.reduction); };
        Shield.prototype.getItemState = function () {
            return {
                magicProperties: this.magicProperties,
                level: this.level,
                rarity: this.rarity,
                type: this.type,
                imageType: this.imageType,
                fixedFullName: this.fixedFullName,
                // These three identify the type of the item in addition to the specific values (if necessary)
                baseDefense: 0,
                baseDamage: 0,
                baseReduction: this.baseReduction,
                baseAttackSpeed: 0
            };
        };
        Shield._shieldPropertyTable = [{ chance: 3, property: "flat_reduction" },
            { chance: 2, property: "percent_reduction" }];
        Shield.Shields = {
            "Ward": { low: 1.7, high: 2.3, flat: 2 },
            "Holy Shield": { low: 1.5, high: 2.0, flat: 2 },
            "Round Shield": { low: 1.3, high: 1.8, flat: 2 },
            "Aspis": { low: 1.1, high: 1.6, flat: 5 },
            "Bulwark": { low: 1, high: 1.5, flat: 6 },
            "Aegis": { low: 1, high: 1.4, flat: 4 },
            "Protector": { low: 1, high: 1.4, flat: 2 },
            "Heavy Shield": { low: 0.7, high: 1, flat: 5 },
            "Shield": { low: 1, high: 1.2, flat: 0 },
        };
        return Shield;
    }(Item));
    RogueRpg.Shield = Shield;
    var Armor = /** @class */ (function (_super) {
        __extends(Armor, _super);
        function Armor(level, rarity, type, state) {
            var _this = _super.call(this, level, rarity, state) || this;
            if (state) {
                _this.baseDefense = state.baseDefense;
            }
            else {
                if (type) {
                    _this.type = type;
                }
                else {
                    var roll = RogueRpg.Helpers.game.playerRandom(true);
                    if (roll > 0.9 && Math.random() * level > 4 && rarity > 3) {
                        _this.type = "Battle Robe";
                    }
                    else if (roll > 0.8 && Math.random() * level > 10 && rarity > 2) {
                        _this.type = "Red Robes";
                    }
                    else if (roll > 0.9 && level * Math.random() > 13 && rarity > 1) {
                        _this.type = "Dark Armor";
                    }
                    else if (roll > 0.85 && level * Math.random() > 12) {
                        _this.type = "Splint Mail";
                    }
                    else if (roll > 0.75 && level * Math.random() > 9) {
                        _this.type = "Breastplate";
                    }
                    else if (roll > 0.6 && level * Math.random() > 6) {
                        _this.type = "Chainmail";
                    }
                    else if (roll > 0.4 && level * Math.random() > 3) {
                        _this.type = "Leather Vest";
                    }
                    else {
                        _this.type = "Tunic";
                    }
                }
                var def = Armor.Armors[_this.type];
                _this.baseDefense = randInt(level * def.low, level * def.high + def.highFlat) + def.flat;
                if (rarity > 4) {
                    _this.baseDefense = Math.floor(_this.baseDefense * 1.3);
                }
                if (rarity == 6) {
                    var nameSelection = Math.random();
                    if (nameSelection < 0.3) {
                        _this.fixedFullName = RogueRpg.Helpers.SelectOne(ItemNames.SpecialArmorNames);
                    }
                }
                if (rarity >= 7) {
                    _this.baseDefense = Math.floor(_this.baseDefense * 1.5);
                    _this.fixedFullName = RogueRpg.Helpers.SelectOne(ItemNames.ImpossibleArmorNames);
                }
            }
            return _this;
        }
        Object.defineProperty(Armor.prototype, "defense", {
            get: function () {
                var defense = this.baseDefense;
                defense += this.getPropertyValue("flat_defense");
                defense *= 1 + this.getPropertyValue("percent_defense") / 100;
                return Math.round(defense);
            },
            enumerable: true,
            configurable: true
        });
        Armor.prototype.getPropertyTable = function () {
            var table = [];
            table = table.concat(Armor._armorPropertyTable);
            table = table.concat(_super.prototype.getPropertyTable.call(this));
            return table;
        };
        Armor.prototype.getMainStatText = function () { return "防御: " + green(this.defense); };
        Armor.prototype.getItemState = function () {
            return {
                magicProperties: this.magicProperties,
                level: this.level,
                rarity: this.rarity,
                type: this.type,
                imageType: this.imageType,
                fixedFullName: this.fixedFullName,
                // These three identify the type of the item in addition to the specific values (if necessary)
                baseDefense: this.baseDefense,
                baseDamage: 0,
                baseReduction: 0,
                baseAttackSpeed: 0
            };
        };
        Armor._armorPropertyTable = [{ chance: 3, property: "flat_defense" },
            { chance: 2, property: "percent_defense" }];
        Armor.Armors = {
            "Battle Robe": { low: 1.6, high: 2.0, flat: 12, highFlat: 10 },
            "Red Robes": { low: 1.5, high: 1.9, flat: 2, highFlat: 5 },
            "Dark Armor": { low: 1.4, high: 1.8, flat: 15, highFlat: 12 },
            "Splint Mail": { low: 1.2, high: 1.7, flat: 12, highFlat: 10 },
            "Breastplate": { low: 1.3, high: 1.6, flat: 10, highFlat: 8 },
            "Chainmail": { low: 1.2, high: 1.5, flat: 7, highFlat: 5 },
            "Leather Vest": { low: 1.2, high: 1.4, flat: 5, highFlat: 4 },
            "Tunic": { low: 1.1, high: 1.3, flat: 2, highFlat: 2 }
        };
        return Armor;
    }(Item));
    RogueRpg.Armor = Armor;
    var Accessory = /** @class */ (function (_super) {
        __extends(Accessory, _super);
        function Accessory(level, rarity, type, state) {
            var _this = _super.call(this, level, rarity, state) || this;
            _this._baseAttackSpeed = 0;
            if (state) {
                _this._baseAttackSpeed = state.baseAttackSpeed;
            }
            else {
                _this.type = "Ring";
                _this.imageType = RogueRpg.Helpers.SelectOne(["GoldRing", "GoldRing2", "GoldRing3", "GoldRing4", "GoldRing5",
                    "SilverRing", "SilverRing2", "SilverRing3", "SilverRing4", "SilverRing5"]);
                _this._baseAttackSpeed = 1500 + (1 - RogueRpg.Helpers.game.playerRandom(true)) * 2000 + (1 - RogueRpg.Helpers.game.playerRandom(true)) * 800;
                if (RogueRpg.Level[RogueRpg.L.DropChanceDelay]) {
                    // this._baseAttackSpeed *= 0.85; // Further increase the attack speed with the ability
                    _this._baseAttackSpeed = Math.min(_this._baseAttackSpeed, 1800); // Never allow a bad drop with the ability
                    _this._baseAttackSpeed *= 0.85; // Further increase the attack speed with the ability
                }
                _this._baseAttackSpeed = _this._baseAttackSpeed * (1 - (level) / (level + 40));
                if (rarity == 5) {
                    _this._baseAttackSpeed = _this._baseAttackSpeed * 0.9;
                }
                if (rarity == 6) {
                    _this._baseAttackSpeed = _this._baseAttackSpeed * 0.7;
                    var nameSelection = Math.random();
                    if (nameSelection < 0.4) {
                        _this.fixedFullName = RogueRpg.Helpers.SelectOne(ItemNames.SpecialRingNames);
                    }
                }
                if (rarity >= 7) {
                    _this._baseAttackSpeed = _this._baseAttackSpeed * 0.65;
                    _this.fixedFullName = RogueRpg.Helpers.SelectOne(ItemNames.ImpossibleRingNames);
                }
                _this._baseAttackSpeed = Math.ceil(_this._baseAttackSpeed);
            }
            return _this;
        }
        Object.defineProperty(Accessory.prototype, "attacksPerSecond", {
            get: function () {
                return 1000 / this._baseAttackSpeed;
            },
            enumerable: true,
            configurable: true
        });
        Accessory.prototype.getMainStatText = function () { return "每秒攻击: +" + green(Math.floor(10000 / this._baseAttackSpeed) / 10); };
        Accessory.prototype.getPropertyTable = function () {
            var table = [];
            table = table.concat(Accessory._accessoryPropertyTable);
            table = table.concat(_super.prototype.getPropertyTable.call(this));
            return table;
        };
        Accessory.prototype.getItemState = function () {
            return {
                magicProperties: this.magicProperties,
                level: this.level,
                rarity: this.rarity,
                type: this.type,
                imageType: this.imageType,
                fixedFullName: this.fixedFullName,
                // These three identify the type of the item in addition to the specific values (if necessary)
                baseDefense: 0,
                baseDamage: 0,
                baseReduction: 0,
                baseAttackSpeed: this._baseAttackSpeed
            };
        };
        Accessory._accessoryPropertyTable = [{ chance: 2, property: "flat_speed" },
            { chance: 2, property: "percent_speed" }];
        return Accessory;
    }(Item));
    RogueRpg.Accessory = Accessory;
    var PotionEffect;
    (function (PotionEffect) {
        PotionEffect[PotionEffect["Maxlife"] = 0] = "Maxlife";
        PotionEffect[PotionEffect["Strength"] = 1] = "Strength";
        PotionEffect[PotionEffect["Dex"] = 2] = "Dex";
        PotionEffect[PotionEffect["Healing"] = 3] = "Healing";
        PotionEffect[PotionEffect["Experience"] = 4] = "Experience";
        PotionEffect[PotionEffect["Speed"] = 5] = "Speed";
        PotionEffect[PotionEffect["Luck"] = 6] = "运气";
        PotionEffect[PotionEffect["SkillPoint"] = 7] = "SkillPoint";
        PotionEffect[PotionEffect["Clear"] = 8] = "Clear";
        PotionEffect[PotionEffect["Damage"] = 9] = "Damage";
        PotionEffect[PotionEffect["Defense"] = 10] = "Defense";
        PotionEffect[PotionEffect["Reduction"] = 11] = "Reduction"; // PotionReduction
    })(PotionEffect = RogueRpg.PotionEffect || (RogueRpg.PotionEffect = {}));
    var DroppedPotion = /** @class */ (function () {
        function DroppedPotion(potion, drawLocation) {
            this.potion = potion;
            this.drawLocation = drawLocation;
        }
        return DroppedPotion;
    }());
    RogueRpg.DroppedPotion = DroppedPotion;
    var Potion = /** @class */ (function () {
        function Potion(effect, value) {
            this.description = "单独使用项目。未使用的魔药可以转移到下一场比赛。";
            this.effects = [];
            this.values = [];
            if (typeof effect == "number") {
                this.effects.push(effect);
                this.values.push(value);
                switch (this.effects[0]) {
                    case PotionEffect.Experience:
                        this.image = "PotionRainbow";
                        this.name = "Experience Potion";
                        break;
                    case PotionEffect.Maxlife:
                        this.image = "PotionGreen";
                        this.name = "+Life Potion";
                        break;
                    case PotionEffect.Clear:
                        this.image = "PotionGrey";
                        this.name = "Heroic Potion";
                        break;
                    case PotionEffect.Dex:
                        this.image = "PotionBlue";
                        this.name = "+Dex Potion";
                        break;
                    case PotionEffect.Healing:
                        this.image = "PotionRed";
                        this.name = "Healing Potion";
                        break;
                    case PotionEffect.Luck:
                        this.image = "PotionYellow";
                        this.name = "+Luck Potion";
                        break;
                    case PotionEffect.SkillPoint:
                        this.image = "PotionPurple";
                        this.name = "Skill Point Potion";
                        break;
                    case PotionEffect.Damage:
                        this.image = "PotionDamage";
                        this.name = "+Damage Potion";
                        break;
                    case PotionEffect.Reduction:
                        this.image = "PotionReduction";
                        this.name = "+Reduction Potion";
                        break;
                    case PotionEffect.Defense:
                        this.image = "PotionDefense";
                        this.name = "+Defense Potion";
                        break;
                    case PotionEffect.Speed:
                        this.image = "PotionWhite";
                        this.name = "+Speed Potion";
                        break;
                    case PotionEffect.Strength:
                        this.image = "PotionOrange";
                        this.name = "+Strength Potion";
                        break;
                    default:
                        this.image = "PotionRed";
                }
            }
            else {
                this.image = "PotionRed";
                this.name = "Useless potion";
            }
        }
        Potion.getStatsString = function (pot) {
            var text = "";
            for (var i = 0; i < pot.effects.length; i++) {
                var effect = pot.effects[i];
                var value = pot.values[i];
                if (effect === PotionEffect.Healing) {
                    text += Potion.effectToString(effect) + ": " + value + "%<br />";
                }
                else if (effect === PotionEffect.Clear) {
                    text = "毫不费力地清理掉当前的地板。";
                }
                else {
                    text += Potion.effectToString(effect) + ": +" + value + "<br />";
                }
            }
            return text;
        };
        Potion.effectToString = function (effect) {
            switch (effect) {
                case PotionEffect.Maxlife:
                    return "Life";
                case PotionEffect.Dex:
                    return "Dex";
                case PotionEffect.Healing:
                    return "Healing";
                case PotionEffect.Luck:
                    return "Luck";
                case PotionEffect.SkillPoint:
                    return "Skill Point";
                case PotionEffect.Speed:
                    return "Speed";
                case PotionEffect.Strength:
                    return "Strength";
                case PotionEffect.Damage:
                    return "Damage";
                case PotionEffect.Defense:
                    return "Defense";
                case PotionEffect.Reduction:
                    return "Reduction";
                case PotionEffect.Experience:
                    return "Experience";
                default:
                    return "Unknown";
            }
        };
        // Computes a non-randomized potion out of the two provided
        Potion.getCombinedPotion = function (first, second) {
            var result = new Potion();
            for (var i = 0; i < first.effects.length; i++) {
                Potion.addNewEffect(result, first.effects[i], first.values[i]);
            }
            for (var i = 0; i < second.effects.length; i++) {
                Potion.addNewEffect(result, second.effects[i], second.values[i]);
            }
            result.name = "Combined Potion";
            return result;
        };
        Potion.addNewEffect = function (potion, effect, value) {
            var effectIndex = potion.effects.indexOf(effect);
            if (effectIndex >= 0) {
                potion.values[effectIndex] += value;
            }
            else {
                potion.effects.push(effect);
                potion.values.push(value);
            }
        };
        return Potion;
    }());
    RogueRpg.Potion = Potion;
})(RogueRpg || (RogueRpg = {}));
//# sourceMappingURL=Items.js.map