var RogueRpg;
(function (RogueRpg) {
    "use strict";
    RogueRpg.L = {
        Life2: "More Life",
        Str2: "More Strength",
        Dex2: "More Dexterity",
        Dmg2: "More Damage",
        Def2: "More Defense",
        Speed2: "More Speed",
        Luck2: "More Luck",
        Life3: "Healthy",
        Str3: "Strong",
        Dex3: "Dexterous",
        Dmg3: "Powerful",
        Def3: "Tough",
        Speed3: "Quick",
        Luck3: "Lucky",
        StrBonusDmgRatio: "Bull's Strength",
        StrBonusHpRatio: "Heart of the Elephant",
        DexBonusDefRatio: "Fox's Agility",
        DexBonusDelayRatio: "Cobra Technique",
        HpRatioIsFromDex: "Badger's Fortitude",
        WeakenOnHit: "Crippling Malice",
        HeartDropChance: "King of Hearts",
        DoubleExp: "Grandmaster",
        CounterattackThornsWeapon: "Volatile Aura",
        Riposte: "Riposte",
        Dodge: "Dodge",
        CounterattackAOE: "Sweeping Retaliation",
        AttackWhileMoving: "Mobile Violence",
        CounterattackResetDelay: "Painful Reminder",
        LuckOnCombatEffects: "Combat Luck",
        IncreasedCritChance: "Precise Strikes",
        IncreasedCritDamage: "Powerful Crits",
        BigFlatLuck: "+Luck",
        DropChanceDmg: "+Damage Drop",
        DropChanceDef: "+Def Drop",
        DropChanceLife: "+Life Drop",
        DropChanceStr: "+Strength Drop",
        DropChanceDex: "+Dexterity Drop",
        DropChanceSpeed: "+Speed Drop",
        DropChanceLuck: "+Luck Drop",
        DropChanceSpeedPercent: "+% Speed Drop",
        DropChanceDelay: "Ring +Attacks Drop",
        DropChanceStrShield: "Shield +Strength Drop",
        DropChanceLifeArmor: "Armor +Life Drop",
        DropChanceDefPercent: "+% Def Drop",
        DropChanceDmgPercent: "+% Damage Drop",
        DropChanceReduction: "+Reduction Drop",
        DropChanceLifestealWeapon: "Weapon Lifesteal Drop",
        SpeedToStr: "Stomping Steps",
        DmgToDef: "The Best Defense",
        DefToDmg: "The Best Offense",
        LifeToDmg: "Vital Strikes",
        DmgToLife: "Thrive on Power",
        FlatDmgStr: "Dmg and Str",
        DmgToSpeed: "Sharp Steps",
        LuckyStrike: "Lucky Strike",
        DefToLife: "Thrive on Toughness",
        FlatDefStr: "Def and Str",
        FlatDefDex: "Def and Dex",
        FlatDefSpeed: "Def and Spd",
        FlatDefLuck: "Def and Luck",
        LifeToStr: "Well of Power",
        LifeToDex: "Well of Quickness",
        SpeedToLife: "Marathoner",
        FlatLifeLuck: "Life and Luck",
        DexToStr: "Mechanical Advantage",
        StrToDex: "Controlled Strength",
        StrToSpeed: "Powerful Strides",
        FlatStrLuck: "Str and Luck",
        SpeedToDex: "Lithe",
        LuckToDex: "Dancer",
        FlatLuckSpeed: "Luck and Spd",
        SpeedToDef: "Prancer",
        BonusExp: "Learner",
        ChanceDoubleExp: "Quick Study",
        BonusExpLowLife: "Trial by Fire",
        ExpButWeak: "Knowledge through Struggle",
        FlatLifesteal: "Lifesteal",
        Cleave: "Cleave",
        Bloodied: "Bloodied",
        SlowButStrong: "Slow but Strong",
        SpeedOnFullLife: "Full of Life",
        Sprinter: "Sprinter",
        FlatDelayReduction: "Accelerating Strikes",
        DropChanceFast: "Master of Swiftness",
        DropChanceSlow: "Master of Power",
        SpeedWithFast: "Lightning Charge",
        SpeedWithSlow: "Thunder Clap",
        ReducedDelay: "Faster Attacks",
        ExpOnFloor: "Archaeology",
        ShardFlatBonus: "Devoted Researcher",
        ExplodeOnLevel: "Uncontained Wisdom",
        NoLifesteal: "Thirst of the Vampire",
        LifePercentSteals: "Fragile Thirst",
        ReductionWhileMoving: "Shield of Wind",
        DefWhileMoving: "Armor of Wind",
        ReduceDelayOnDamage: "Fueled by Pain",
        DefOnLowLife: "Tempered by Pain",
        Berserking: "Berserker Frenzy",
        Disarm: "Disarming Technique",
        StrToLifesteal: "Overwhelming Persuasion",
        DexToLifesteal: "Surgical Precision",
        LuckyDefense: "Lucky Defense",
        UseDexInDmg: "Lethal Accuracy",
        UseStrInDef: "Rock-solid Body",
        UseStrInDelay: "Applied Force",
        Greedless: "Free from Desire",
        MoreMaxLife: "Enduring Resilience",
        Orb: "Fiery Satellite",
        AmplifyingAttacks: "Armor Shred",
        ToughSkin: "Tough Skin",
        ReduceDamage: "Roll with the Punches",
        SweepSpins: "Spinning Sweep",
        SweepStun: "Stunning Sweep",
        StabDuration: "Longer Stab",
        StabTargets: "More Stab",
        FlashCooldown: "More Flashes",
        FlashDamage: "Stronger Flashes",
        KickKnockback: "Explosive Landing",
        KickRicochet: "Flying Ricochet",
        ArrowsAim: "Aimed Arrows",
        ArrowsDouble: "Repeated Fire",
        SpeedLimit: "Speed Limit",
    };
    var kv = /** @class */ (function () {
        function kv(key, value) {
            this.key = key;
            this.value = value;
        }
        return kv;
    }());
    RogueRpg.kv = kv;
    var LevelUpPoint = /** @class */ (function () {
        function LevelUpPoint(name, description, ranks, statPoints) {
            this.name = name;
            this.description = description;
            this.ranks = ranks;
            this.statPoints = statPoints;
            LevelUpPoint.all[name] = this;
            this.id = this.name;
        }
        LevelUpPoint.all = {};
        // TODO: At some point in the future, once most people have updated, move all
        // level references to use id instead of name
        LevelUpPoint.SmallLevelUpPoints = [
            new LevelUpPoint("Life", "增加6点生命值", 1000, [new kv("flat_life", 6)]),
            new LevelUpPoint("Str", "增加+2力量", 1000, [new kv("flat_strength", 2)]),
            new LevelUpPoint("Dex", "增加+2敏捷度", 1000, [new kv("flat_dexterity", 2)]),
            new LevelUpPoint("Dmg", "增加+1基础伤害", 1000, [new kv("flat_damage", 1)]),
            new LevelUpPoint("Def", "增加+1基地防御", 1000, [new kv("flat_defense", 1)]),
            new LevelUpPoint("Speed", "增加+1速度", 1000, [new kv("flat_speed", 1)]),
            new LevelUpPoint("Luck", "增加+2运气", 1000, [new kv("flat_luck", 2)]),
        ];
        LevelUpPoint.LargeLevelUpPoints = [
            new LevelUpPoint(RogueRpg.L.Life2, "增加40点生命", 1000, [new kv("flat_life", 40)]),
            new LevelUpPoint(RogueRpg.L.Str2, "增加+7力量", 1000, [new kv("flat_strength", 7)]),
            new LevelUpPoint(RogueRpg.L.Dex2, "增加+7敏捷", 1000, [new kv("flat_dexterity", 7)]),
            new LevelUpPoint(RogueRpg.L.Dmg2, "增加5点基础伤害", 1000, [new kv("flat_damage", 5)]),
            new LevelUpPoint(RogueRpg.L.Def2, "增加+12基础防御", 1000, [new kv("flat_defense", 10)]),
            new LevelUpPoint(RogueRpg.L.Speed2, "增加+1速度", 1000, [new kv("flat_speed", 1)]),
            new LevelUpPoint(RogueRpg.L.Luck2, "增加+9运气", 1000, [new kv("flat_luck", 9)]),
        ];
        LevelUpPoint.DualLevelUpPoints = [
            new LevelUpPoint(RogueRpg.L.FlatDefStr, "获得+8防御和+4力量", 2, [new kv("flat_defense", 8), new kv("flat_strength", 4)]),
            new LevelUpPoint(RogueRpg.L.FlatDefDex, "获得+8防御和+4敏捷", 2, [new kv("flat_defense", 8), new kv("flat_dexterity", 4)]),
            new LevelUpPoint(RogueRpg.L.FlatDefSpeed, "获得+8防御和+1速度", 2, [new kv("flat_defense", 8), new kv("flat_speed", 1)]),
            new LevelUpPoint(RogueRpg.L.FlatDefLuck, "获得+8防御和+4运气", 2, [new kv("flat_defense", 8), new kv("flat_luck", 4)]),
            new LevelUpPoint(RogueRpg.L.FlatDmgStr, "获得+4伤害和+4力量", 2, [new kv("flat_damage", 4), new kv("flat_strength", 4)]),
            new LevelUpPoint(RogueRpg.L.FlatLifeLuck, "获得+16生命和+4运气。", 2, [new kv("flat_life", 16), new kv("flat_luck", 4)]),
            new LevelUpPoint(RogueRpg.L.FlatStrLuck, "获得+ 4物理攻击力和+ 4运气", 2, [new kv("flat_strength", 4), new kv("flat_luck", 4)]),
            new LevelUpPoint(RogueRpg.L.FlatLuckSpeed, "获得+4的运气和+1的速度。", 2, [new kv("flat_luck", 4), new kv("flat_speed", 4)]),
        ];
        LevelUpPoint.MultiplierBonuses = [
            new LevelUpPoint(RogueRpg.L.Life3, "增加最大生命值10%。", 99, [new kv("percent_life", 10)]),
            new LevelUpPoint(RogueRpg.L.Str3, "强度增加10%", 99, [new kv("percent_strength", 10)]),
            new LevelUpPoint(RogueRpg.L.Dex3, "敏捷增加10%", 99, [new kv("percent_dexterity", 10)]),
            new LevelUpPoint(RogueRpg.L.Dmg3, "增加总伤害10%。", 99, [new kv("percent_damage", 10)]),
            new LevelUpPoint(RogueRpg.L.Def3, "增加总防御率10%。", 99, [new kv("percent_defense", 10)]),
            new LevelUpPoint(RogueRpg.L.Luck3, "提升10%的运气", 99, [new kv("percent_luck", 10)]),
        ];
        LevelUpPoint.DropChanceModifiers = [
            new LevelUpPoint(RogueRpg.L.DropChanceDmg, "在掉落的武器上造成+伤害的几率增加2倍。", 1, [new kv("drop_flat_damage", 1)]),
            new LevelUpPoint(RogueRpg.L.DropChanceDmgPercent, "三倍的几率在掉落的武器上造成+%的伤害。", 1, [new kv("drop_percent_damage", 2)]),
            //new LevelUpPoint(L.DropChanceLife, "2x chance of +Life on dropped items", 1, [new kv("drop_flat_life", 1)]),
            new LevelUpPoint(RogueRpg.L.DropChanceStr, "在掉落的物品上增加2倍的强度。", 1, [new kv("drop_flat_strength", 1)]),
            new LevelUpPoint(RogueRpg.L.DropChanceDex, "在掉落的物品上增加了2倍的灵活性。", 1, [new kv("drop_flat_dexterity", 1)]),
            new LevelUpPoint(RogueRpg.L.DropChanceLuck, "在掉落的物品上加好运的概率是2x。", 5, [new kv("drop_flat_luck", 1)]),
            // new LevelUpPoint(L.DropChanceSpeedPercent, "2x chance and +50% power of +%Speed on dropped rings", 1, [new kv("drop_percent_speed", 1), new kv("drop_power_percent_speed", 50)]),
            new LevelUpPoint(RogueRpg.L.DropChanceDelay, "在掉落的戒指上增加每秒+攻击的力量。", 1, [new kv("drop_power_aps", 1)]),
            new LevelUpPoint(RogueRpg.L.DropChanceStrShield, "4倍的机会和+30%的力量在掉落的护盾上。", 1, [new kv("drop_shield_flat_strength", 3), new kv("drop_shield_power_flat_life", 30)]),
            new LevelUpPoint(RogueRpg.L.DropChanceLifeArmor, "4倍的机会和+25%的力量在掉落的装甲上。", 1, [new kv("drop_armor_flat_life", 3), new kv("drop_armor_power_flat_life", 30)]),
            new LevelUpPoint(RogueRpg.L.DropChanceLifestealWeapon, "三倍的机会在掉落的武器上偷取生命。", 1, [new kv("drop_weapon_flat_lifesteal", 2)]),
            new LevelUpPoint(RogueRpg.L.DropChanceFast, "投掷武器的速度更快。", 2),
            new LevelUpPoint(RogueRpg.L.DropChanceSlow, "放弃的武器更可能是缓慢的。", 2),
            new LevelUpPoint(RogueRpg.L.DropChanceDef, "增加被掉落的装甲上出现+防御的几率。", 1),
            new LevelUpPoint(RogueRpg.L.DropChanceDefPercent, "显著增加了在掉落的装甲上出现+%防御的几率。", 1),
        ];
        // Cross-stat bonuses
        /*
        public static CrossStatBonuses: LevelUpPoint[] = [
            new LevelUpPoint(L.SpeedToStr, "200% of your speed above 25 is added to your strength", "Str.png", 2),
            new LevelUpPoint(L.DmgToDef, "9% of your average damage is added to your defense", "Str.png", 2),
            new LevelUpPoint(L.DefToDmg, "20% of your defense percentage also increases your damage", "Str.png", 2),
            new LevelUpPoint(L.LifeToDmg, "2% of your life is added to your total damage", "Str.png", 2),
            new LevelUpPoint(L.DmgToLife, "10% of your total damage is added to your maximum life", "Str.png", 2),
            new LevelUpPoint(L.DmgToSpeed, "1% of your average damage is added to your speed, rounded up", "Str.png", 2),
            new LevelUpPoint(L.DefToLife, "5% of your total defense is added to your base life", "Str.png", 2),
            new LevelUpPoint(L.LifeToStr, "1% of your life is added to your base strength", "Str.png", 2),
            new LevelUpPoint(L.LifeToDex, "1% of your life is added to your base dexterity", "Str.png", 2),
            new LevelUpPoint(L.SpeedToLife, "8x of your speed over 25 is added to your Life", "Str.png", 2),
            new LevelUpPoint(L.DexToStr, "10% of your dexterity is added to your strength", "Str.png", 2),
            new LevelUpPoint(L.StrToDex, "10% of your strength is added to your dexterity", "Str.png", 2),
            new LevelUpPoint(L.StrToSpeed, "Your speed is increased by 1% of your strength", "Str.png", 2),
            new LevelUpPoint(L.SpeedToDex, "200% of your speed above 25 is added to your dexterity", "Str.png", 2),
            new LevelUpPoint(L.LuckToDex, "25% of your luck is granted as bonus dexterity", "Str.png", 2),
            new LevelUpPoint(L.SpeedToDef, "400% of your speed above 25 is added to your defense.", "Def.png", 1),
        ];
        */
        LevelUpPoint.EmpowerSeries = [
            new LevelUpPoint(RogueRpg.L.StrBonusDmgRatio, "每1强度获得额外的0.2％伤害", 3, [new kv("ratiobonus_strength_damage", 15)]),
            new LevelUpPoint(RogueRpg.L.DexBonusDefRatio, "每1个灵巧获得额外的0.2％防御", 3, [new kv("ratiobonus_dexterity_defense", 15)]),
            new LevelUpPoint(RogueRpg.L.DexBonusDelayRatio, "每1个灵巧获得额外0.2％的攻击速度", 3, [new kv("ratiobonus_dexterity_ias", 15)]),
            new LevelUpPoint(RogueRpg.L.StrBonusHpRatio, "每1强度增加0.2%的生命。", 3, [new kv("ratiobonus_strength_life", 15)]),
        ];
        /*
                public static RespecializeSeries: LevelUpPoint[] = [
                    new LevelUpPoint(L.HpRatioIsFromDex, "Dexterity, instead of Strength, will be used for bonus life computations", "Life.png", 1),
                    new LevelUpPoint(L.UseDexInDmg, "Damage bonus now depends half on Str and half on Dex", "Dex.png", 1),
                    new LevelUpPoint(L.UseStrInDef, "Defense bonus now depends half on Str and half on Dex", "Str.png", 1),
                    new LevelUpPoint(L.UseStrInDelay, "Attack speed bonus now depends half on Str and half on Dex", "Str.png", 1),
                ];
                */
        LevelUpPoint.Series = {
            Luck: {
                items: [
                    new LevelUpPoint(RogueRpg.L.LuckyStrike, "增加你的攻击的可变性，使你的总伤害达到0%-200%。(当前的: 50%-150%)", 1),
                    new LevelUpPoint(RogueRpg.L.Greedless, "你有75%的运气，但运气不再影响物品掉落。", 1),
                    new LevelUpPoint(RogueRpg.L.LuckyDefense, "每次你受到伤害时，你会得到50%-150%的损失，你的幸运奖金也适用。这个范围可以通过幸运的攻击来修改。", 1),
                    new LevelUpPoint(RogueRpg.L.Dodge, "当敌人攻击你时，有10%的几率闪避攻击(受到500点的影响)。", 3),
                    new LevelUpPoint(RogueRpg.L.LuckOnCombatEffects, "你的运气加值现在适用于你的机会，暴击，阻击，还击和反击。", 1),
                    new LevelUpPoint(RogueRpg.L.BigFlatLuck, "获得+ 12的运气", 25),
                    new LevelUpPoint(RogueRpg.L.DropChanceLuck, "在掉落的物品上加好运的概率是2x。", 5),
                ],
                description: "“运气”技能会让运气影响更多的游戏动作。"
            },
            Flurry: {
                items: [
                    new LevelUpPoint(RogueRpg.L.FlatDelayReduction, "减少攻击的基础延迟70。", 1),
                    new LevelUpPoint(RogueRpg.L.SpeedWithFast, "在使用快速武器时获得3个基本速度和10%的减少武器延迟。", 1),
                    new LevelUpPoint(RogueRpg.L.Disarm, "每一次攻击都给你的对手一个非常小的机会，让你的对手立刻放下武器。", 1),
                    new LevelUpPoint(RogueRpg.L.DropChanceFast, "投掷武器的速度更快。", 2),
                    new LevelUpPoint(RogueRpg.L.NoLifesteal, "你不再受生命之偷的影响，但每一次攻击都能治愈你生命中0.8%的生命。", 1),
                    // new LevelUpPoint(L.ReduceDelayOnDamage, "Whenever an enemy hits you, your remaining delay decreases by 120", 2),
                    new LevelUpPoint(RogueRpg.L.LifeToDmg, "你生命中的1%被加到你的全部伤害中。", 3),
                    new LevelUpPoint(RogueRpg.L.ReducedDelay, "减少武器技能CD10%。", 2),
                    new LevelUpPoint(RogueRpg.L.AmplifyingAttacks, "对敌人造成的伤害增加2%的伤害，叠加。", 3),
                ],
                description: "“疾风”技能让你在使用“快速”武器时更有效(延迟750或更少)"
            },
            Crusher: {
                items: [
                    new LevelUpPoint(RogueRpg.L.SlowButStrong, "你的总损失增加了60%，总延迟增加了50%。", 3),
                    new LevelUpPoint(RogueRpg.L.SpeedWithSlow, "在使用慢速武器时，获得3个基本速度和+15%的额外伤害。", 1),
                    new LevelUpPoint(RogueRpg.L.DropChanceSlow, "放弃的武器更可能是缓慢的。", 2),
                    new LevelUpPoint(RogueRpg.L.Cleave, "杀死敌人重置你的攻击延迟。", 1),
                    new LevelUpPoint(RogueRpg.L.CounterattackThornsWeapon, "当敌人攻击你时，他们会消耗你20%的武器伤害。", 10),
                    new LevelUpPoint(RogueRpg.L.Riposte, "当敌人攻击你时，你有+7%的机会来阻止伤害并进行反击。", 3),
                    new LevelUpPoint(RogueRpg.L.CounterattackAOE, "当敌人攻击你时，你有+6%的几率对所有附近的敌人进行反击，造成50%的伤害。生命偷取并不适用。", 5),
                    new LevelUpPoint(RogueRpg.L.CounterattackResetDelay, "当你受到伤害时，有40 %的几率重置你的攻击延迟。", 1),
                    new LevelUpPoint(RogueRpg.L.ToughSkin, "每个级别的基础防御增加+1(可叠加)", 2),
                ],
                description: "'当你使用“慢”武器时，你的技能会让你更有效率(延迟800或更多)"
            },
            Berserker: {
                items: [
                    new LevelUpPoint(RogueRpg.L.DefOnLowLife, "获得最多45 %的额外防御，与你当前失去的生命成正比", 1),
                    new LevelUpPoint(RogueRpg.L.Berserking, "承受30 %的额外伤害，但获得与你失去的生命成正比的+ 60 %伤害和+ 30 %攻击速度。", 1),
                    new LevelUpPoint(RogueRpg.L.BonusExpLowLife, "任何时候杀死敌人，如果你的生命少于60 %，你将获得+ 25 %的额外经验", 1),
                    new LevelUpPoint(RogueRpg.L.FlatLifesteal, "获得永久+ 4 %的生命值", 2),
                    new LevelUpPoint(RogueRpg.L.Bloodied, "你的生命不能超过50 %。你所受的伤害减少40 %。", 1),
                    new LevelUpPoint(RogueRpg.L.IncreasedCritChance, "增加暴击几率10%。", 9),
                    new LevelUpPoint(RogueRpg.L.IncreasedCritDamage, "增加暴击伤害100%。", 99),
                    new LevelUpPoint(RogueRpg.L.DropChanceLifestealWeapon, "三倍的机会在掉落的武器上偷取生命。", 1, [new kv("放下武器减少命偷。", 2)]),
                ],
                description: "“勇士”的技能会增加你的生命力，并在你生命力低下时赋予你力量"
            },
            Scholar: {
                items: [
                    new LevelUpPoint(RogueRpg.L.BonusExp, "所有来源获得+ 12％的奖金。", 99),
                    new LevelUpPoint(RogueRpg.L.DoubleExp, "获得双倍经验。 物品掉落现在基于你的等级，但不能比稀有物降得更强。", 1),
                    new LevelUpPoint(RogueRpg.L.ExpButWeak, "获得+ 30％的加成经验，但是你的速度和伤害每下降10％。", 2),
                    new LevelUpPoint(RogueRpg.L.ChanceDoubleExp, "获得12％的几率从任何被杀死的敌人处获得两次经验。 不受运气影响。", 8),
                    new LevelUpPoint(RogueRpg.L.ShardFlatBonus, "当你死亡时，获得15％额外的碎片。", 3),
                    new LevelUpPoint(RogueRpg.L.ExplodeOnLevel, "当你获得一个新的等级时，释放一个强大的爆炸。", 1),
                ],
                description: "“学者”技能可以帮助你获得更多的经验、项目和奖励。"
            },
            Athletics: {
                items: [
                    new LevelUpPoint(RogueRpg.L.DefWhileMoving, "移动时，所有来源的伤害降低33％。", 1),
                    new LevelUpPoint(RogueRpg.L.AttackWhileMoving, "每当敌人袭击你时，如果你的攻击准备就绪，你会回击。 如果你正在移动，增加+ 100％的伤害加值。", 1),
                    new LevelUpPoint(RogueRpg.L.SpeedOnFullLife, "当你有完整的生命时，获得40%的奖励速度。", 1),
                    new LevelUpPoint(RogueRpg.L.ExpOnFloor, "当你晋升一层楼时，获得你当前水平所需的35%的经验。不受任何额外奖金的影响。", 1),
                    new LevelUpPoint(RogueRpg.L.Sprinter, "你有+ 5的速度", 1),
                    new LevelUpPoint(RogueRpg.L.WeakenOnHit, "受到伤害的敌人造成的伤害降低15％，移动速度降低10％", 2),
                    new LevelUpPoint(RogueRpg.L.HeartDropChance, "一颗心从敌人和胸部掉落的几率加倍", 2),
                    new LevelUpPoint(RogueRpg.L.MoreMaxLife, "你的基础最大生命值每增加一级+5。 （可叠加）", 99),
                    new LevelUpPoint(RogueRpg.L.ReduceDamage, "所有受到的伤害降低10％", 2),
                    new LevelUpPoint(RogueRpg.L.SpeedLimit, "将速度限制在35。对于高于35的每个速度点，增益+ 2 %", 1),
                ],
                description: "“竞技”技能可以提高你的运动和防守能力。"
            },
            Warrior: {
                items: [
                    new LevelUpPoint(RogueRpg.L.SweepSpins, "横扫旋转两次而不是一次。", 1),
                    new LevelUpPoint(RogueRpg.L.SweepStun, "横扫所有的敌人受影响1秒。", 1),
                ],
                description: "战士'技能增加了扫掠技能的力量"
            },
            Rogue: {
                items: [
                    new LevelUpPoint(RogueRpg.L.StabDuration, "刺伤持续1.5秒，而不是1秒。", 1),
                    new LevelUpPoint(RogueRpg.L.StabTargets, "每次刺伤可以命中3个目标，而不是2个", 1),
                ],
                description: "“盗贼”技能增加了刺伤技能的威力。"
            },
            Mage: {
                items: [
                    new LevelUpPoint(RogueRpg.L.FlashCooldown, "闪现的冷却时间是4秒，而不是6秒", 1),
                    new LevelUpPoint(RogueRpg.L.FlashDamage, "闪现造成1.5倍的损失", 1),
                ],
                description: "'法师'技能增加了闪现技能的力量"
            },
            Monk: {
                items: [
                    new LevelUpPoint(RogueRpg.L.KickKnockback, "飞踢将目标周围的单位打退，使其减速70 %", 1),
                    new LevelUpPoint(RogueRpg.L.KickRicochet, "飞踢可以飞向附近的另一个敌人，如果单位死亡，它也会飞。", 1),
                ],
                description: "“和尚”的技能增加了飞行技能的力量。"
            },
            Hunter: {
                items: [
                    new LevelUpPoint(RogueRpg.L.ArrowsAim, "相反，集中射击会在你瞄准的方向快速射出11支箭。", 1),
                    new LevelUpPoint(RogueRpg.L.ArrowsDouble, "集中射击在第一箭之后发射第二箭", 1),
                ], description: "'和尚'技能增加了箭术技能的力量"
            }
        };
        return LevelUpPoint;
    }());
    RogueRpg.LevelUpPoint = LevelUpPoint;
    RogueRpg.Level = {
        Life: 0,
        Str: 0,
        Dex: 0,
        Dmg: 0,
        Def: 0,
        Speed: 0,
        Luck: 0
    };
})(RogueRpg || (RogueRpg = {}));
//# sourceMappingURL=Levels.js.map