var RogueRpg;
(function (RogueRpg) {
    "use strict";
    var State = /** @class */ (function () {
        function State() {
        }
        return State;
    }());
    var Application;
    (function (Application) {
        function initialize() {
            document.addEventListener('deviceready', onDeviceReady, false);
        }
        Application.initialize = initialize;
        function onDeviceReady() {
            // Handle the Cordova pause and resume events
            document.addEventListener('pause', onPause, false);
            document.addEventListener('resume', onResume, false);
            document.addEventListener('backbutton', onBackButton, false);
            document.addEventListener('menubutton', onMenuButton, false);
            window.addEventListener('resize', onResize, false);
            RogueRpg.Images.load();
            // TODO: Cordova has been loaded. Perform any initialization that requires Cordova here.
            setTimeout(function () {
                try {
                    window.FastClick.attach(document.body);
                }
                catch (ex) {
                    // Do nothing
                }
                try {
                    State.game = new RogueRpg.Game();
                    State.game.initialize();
                }
                catch (ex) {
                    alert("Error starting game. Please report this to the developer:\n\n" + ex.message + "\n--\n" + ex.stack);
                }
            }, 100);
        }
        function onResize() {
            State.game.onResize();
        }
        function onPause() {
            State.game.pauseLoop();
            State.game.persistData();
        }
        function onResume() {
            State.game.onResize();
            if (State.game.inventoryVisible || State.game.classSelectionPaneVisible || State.game.levelUpPaneVisible) {
                // Do nothing - the game should remain paused
            }
            else {
                State.game.beginLoop();
            }
        }
        function onBackButton() {
            State.game.onBackButtonPressed();
        }
        function onMenuButton() {
            State.game.onMenuButtonPressed();
        }
    })(Application = RogueRpg.Application || (RogueRpg.Application = {}));
    window.onload = function () {
        Application.initialize();
    };
})(RogueRpg || (RogueRpg = {}));
//# sourceMappingURL=index.js.map